"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DoublyLinkedList = void 0;

var _LinkedList2 = require("./LinkedList");

var _toollib = require("../common/toollib");

var _LinkedListNode = require("./LinkedListNode");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * 双向链表
 *
 * @export DoublyLinkedList
 * @class DoublyLinkedList
 * @extends {LinkedList}
 */
var DoublyLinkedList = /*#__PURE__*/function (_LinkedList) {
  _inherits(DoublyLinkedList, _LinkedList);

  var _super = _createSuper(DoublyLinkedList);

  function DoublyLinkedList() {
    var customizedComparer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

    _classCallCheck(this, DoublyLinkedList);

    return _super.call(this, customizedComparer);
  }
  /**
   * 向链表末尾添加数据
   *
   * @param {*} data 链表元素的数据
   * @returns true
   * @memberof DoublyLinkedList
   */


  _createClass(DoublyLinkedList, [{
    key: "append",
    value: function append(data) {
      var newNode = new _LinkedListNode.LinkedListNode(data); // 1.判断链表是否为空

      if (this.isEmpty) {
        // 新元素既是首也是尾
        this.__head = newNode;
        this.__tail = newNode;
      } // 2.非空链表时，添加到尾部
      else {
        this.__tail.next = newNode;
        newNode.prev = this.__tail;
        this.__tail = newNode;
      } // 3.计数加1


      this.__count += 1;
      return true;
    }
    /**
     * 向链表指定位置插入元素
     *
     * @param {number} position 插入位置
     * @param {*} data
     * @returns 插入结果：true/false
     * @memberof DoublyLinkedList
     */

  }, {
    key: "insert",
    value: function insert(position, data) {
      // 1.边界检查（插入位置）
      if (position < 0 || position > this.__count) return false;
      var newNode = new _LinkedListNode.LinkedListNode(data); // 2.插入元素时链表为空

      if (this.isEmpty) {
        this.__head = newNode;
        this.__tail = newNode;
      } // 3.链表非空
      else {
        // 3.1插入到链表头部
        if (position === 0) {
          newNode.next = this.__head;
          this.__head.prev = newNode;
          this.__head = newNode;
        } // 3.2插入到链表尾部
        else if (position === this.__count) {
          this.__tail.next = newNode;
          newNode.prev = this.__tail;
          this.__tail = newNode;
        } // 3.3以外
        else {
          var _current = (0, _LinkedListNode.doublyFindAt)(this.size, position, this.__head, this.__tail);

          _current.prev.next = newNode;
          newNode.prev = _current.prev;
          newNode.next = _current;
          _current.prev = newNode;
        }
      } // 4.计数加1


      this.__count += 1;
      return true;
    }
    /**
     * 删除链表指定位置元素
     *
     * @param {number} position 位置下标
     * @returns 删除结果：true/false
     * @memberof DoublyLinkedList
     */

  }, {
    key: "removeAt",
    value: function removeAt(position) {
      // 1.边界检查
      if (position < 0 || position >= this.__count) return false; // 2.只有一个元素

      if (this.size === 1) {
        this.__head = null;
        this.__tail = null;
      } // 3.多个元素的情况
      else {
        // 3.1 删首
        if (position === 0) {
          this.__head = current.next;
          current.next.prev = null;
        } // 3.2 删尾
        else if (position === this.__count - 1) {
          this.__tail = this.__tail.prev;
          this.__tail.next = null;
        } // 3.3 以外
        else {
          var _current2 = (0, _LinkedListNode.doublyFindAt)(this.size, position, this.__head, this.__tail);

          _current2.prev.next = _current2.next;
          _current2.next.prev = _current2.prev;
        }
      } // 4.计数减1


      this.__count -= 1;
      return true;
    }
    /**
     * 删除指定数据的元素
     *
     * @param {*} data 元素数据
     * @returns 返回删除的元素数据
     * @memberof DoublyLinkedList
     */

  }, {
    key: "remove",
    value: function remove(data) {
      // 1.根据指定数据取得下标值
      var index = this.indexOf(data); // 2.检查下标值是否正常取到

      if (index === -1) return false; // 3.根据取到的下标，调用 removeAt 方法进行删除

      return this.removeAt(index);
    }
    /**
     * 更新指定位置元素
     *
     * @param {number} position 位置下标
     * @param {*} data 更新的数据
     * @returns 更新结果：成功true/失败false
     * @memberof DoublyLinkedList
     */

  }, {
    key: "update",
    value: function update(position, data) {
      // 1.边界检查
      if (position < 0 || position >= this.__count) return false; // 2.找到指定下标位置元素（根据所处位置从头或从尾查找）

      var targetNode = (0, _LinkedListNode.doublyFindAt)(this.size, position, this.__head, this.__tail); // 3.修改数据

      targetNode.data = data;
      return true;
    }
    /**
     * 获取指定位置元素的数据
     *
     * @param {number} position 位置下标
     * @returns 元素的数据
     * @memberof DoublyLinkedList
     */

  }, {
    key: "findAt",
    value: function findAt(position) {
      // 1.边界检查
      if (position < 0 || position >= this.__count) return undefined; // 2.判断该位置处于链表前半部分还是后半部分
      //   前半部分的时候，从 head 开始查找
      //   后半部分的时候，从 tail 开始查找

      var reversal = (0, _LinkedListNode.needReversal)(this.size, position); // 3.找到指定位置元素

      var current = reversal ? (0, _LinkedListNode.loopToFind)(position, this.__tail, this.size - 1) : (0, _LinkedListNode.loopToFind)(position, this.__head, null); // 4.返回该节点元素的数据部分

      return current.data;
    }
    /**
     * 根据指定元素数据获取在链表中的位置下标
     *
     * @param {*} data
     * @returns 位置下标
     * @memberof DoublyLinkedList
     */

  }, {
    key: "indexOf",
    value: function indexOf(data) {
      var index = 0;
      var current = this.__head; // 根据指点数据查找节点元素

      while (current) {
        if (this.__comparator(current.data, data)) {
          return index;
        }

        current = current.next;
        index += 1;
      } // 没有找到符合的节点元素


      return -1;
    }
    /**
     * 从尾元素开始遍历
     *
     * @param {function} callback
     * @memberof DoublyLinkedList
     */

  }, {
    key: "backwardTraverse",
    value: function backwardTraverse(callback) {
      // 参数检查（回调函数）
      if (!callback || !(0, _toollib.isFunction)(callback)) return; // 起始元素设为 tail

      var current = this.__tail; // 尾部起始，向前遍历

      while (current) {
        callback(current.data);
        current = current.prev;
      }
    }
    /**
     * 从首元素开始遍历
     *
     * @param {function} callback
     * @memberof DoublyLinkedList
     */

  }, {
    key: "forwardTraverse",
    value: function forwardTraverse(callback) {
      // 参数检查（回调函数）
      if (!callback || !(0, _toollib.isFunction)(callback)) return; // 起始元素设为 head

      var current = this.__head; // 头部起始，向后遍历

      while (current) {
        callback(current.data);
        current = current.next;
      }
    }
    /**
     * 根据指定顺序，遍历双向链表
     *默认为 forwardTravase
     * @param {function} callback
     * @param {boolean} [reversal=false]
     * @memberof DoublyLinkedList
     */

  }, {
    key: "traverse",
    value: function traverse(callback) {
      var reversal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      reversal ? this.backwardTraverse(callback) : this.forwardTraverse(callback);
    }
  }]);

  return DoublyLinkedList;
}(_LinkedList2.LinkedList);

exports.DoublyLinkedList = DoublyLinkedList;