"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ROTATE_RIGHT = exports.ROTATE_LEFT = exports.BalencedBinarySearchTree = void 0;

var _BinarySearchTree2 = require("./BinarySearchTree");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ROTATE_LEFT = false;
exports.ROTATE_LEFT = ROTATE_LEFT;
var ROTATE_RIGHT = true;
/**
* 平衡二叉搜索树
*
* @export
* @class BalencedBinarySearchTree
* @extends {BinarySearchTree}
*/

exports.ROTATE_RIGHT = ROTATE_RIGHT;

var BalencedBinarySearchTree = /*#__PURE__*/function (_BinarySearchTree) {
  _inherits(BalencedBinarySearchTree, _BinarySearchTree);

  var _super = _createSuper(BalencedBinarySearchTree);

  function BalencedBinarySearchTree(customizedComparer) {
    _classCallCheck(this, BalencedBinarySearchTree);

    return _super.call(this, customizedComparer);
  }
  /**
   * 旋转
   *
   * @param {TreeNode} n 旋转的节点 ◎
   * @param {ROTATE_LEFT | ROTATE_RIGHT} [direction=ROTATE_LEFT]
   * @memberof BalencedBinarySearchTree
   */


  _createClass(BalencedBinarySearchTree, [{
    key: "rotate",
    value: function rotate(n) {
      var direction = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ROTATE_LEFT;

      if (direction === ROTATE_LEFT) {
        this.rotateLeft(n);
      } else {
        this.rotateRight(n);
      }
    }
    /**
     * 左旋
     * 
     *   ◎n
     *    \
     *     〇c
     * ↓---------
     *     〇c
     *   　/
     *   ◎n
     * 
     * @param {TreeNode} n 旋转的节点 ◎
     * @memberof BalencedBinarySearchTree
     */

  }, {
    key: "rotateLeft",
    value: function rotateLeft(n) {
      // 1. grand 层
      if (n.isLeftChild) {
        n.parent.left = n.right;
      } else if (n.isRightChild) {
        n.parent.right = n.right;
      }

      n.right.parent = n.parent; // 2. 旋转层

      n.parent = n.right;
      n.right = n.right.left;
      n.right && (n.right.parent = n);
      n.parent.left = n;
    }
    /**
     * 右旋
     * 
     *      ◎n
     *     /
     *    〇c
     * --------↓
     *    〇c
     *   　\
     *      ◎n
     * 
     * @param {TreeNode} n 旋转的节点 ◎
     * @memberof BalencedBinarySearchTree
     */

  }, {
    key: "rotateRight",
    value: function rotateRight(n) {
      // 1. grand 层
      if (n.isLeftChild) {
        n.parent.left = n.left;
      } else if (n.isRightChild) {
        n.parent.right = n.left;
      }

      n.left.parent = n.parent; // 2. 旋转层        

      n.parent = n.left;
      n.left = n.left.right;
      n.left && (n.left.parent = n);
      n.parent.right = n;
    }
  }]);

  return BalencedBinarySearchTree;
}(_BinarySearchTree2.BinarySearchTree);

exports.BalencedBinarySearchTree = BalencedBinarySearchTree;